<template>
  <div>
    <el-tag
      :id="`badge-${mediaPlan.id}`"
      v-if="!inventoryPercent"
      effect="plain"
      @click="getCurrentInventory"
      style="cursor: pointer"
      >Нет данных</el-tag
    >
    <el-tag
      :id="`badge-${mediaPlan.id}`"
      v-else
      :type="getType()"
      @click="getCurrentInventory"
      style="cursor: pointer"
      >{{ inventoryPercent.toFixed(2) }} %
    </el-tag>
  </div>
</template>

<script lang="ts">
import { Vue, Prop, Component } from "vue-property-decorator";
import { MediaPlan } from "@/interfaces/MediaPlan";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { AxiosInstance } from "@/modules/AxiosInstance";

/**
 * Компонент - процент набранного инвентаря медиаплана.
 */
@Component
export default class ComponentInventoryPercent extends Vue {
  /** @property {number|null} inventoryPercent - процент набранного инвентаря медиаплана */
  private inventoryPercent: null | number = null;

  /** @property {MediaPlan} mediaPlan - медиаплан. */
  @Prop({ type: MediaPlan, required: true })
  private readonly mediaPlan!: MediaPlan;

  /**
   * Метод срабатывает после создания компонента.
   */
  mounted(): void {
    // Вызываем запрос инвентаря
    this.getCurrentInventory();
  }
  /**
   * Метод запроса набранного инвентаря.
   */
  @AsyncRequestCatchException
  private async getCurrentInventory(): Promise<void> {
    const loading = this.$loading({
      target: `#badge-${this.mediaPlan.id}`,
      lock: true,
      spinner: "el-icon-loading",
    });
    const response = await AxiosInstance.get(
      "media-plan-search-view/get-media-plan-current-inventory",
      { params: { id: this.mediaPlan.id } }
    );

    setTimeout(() => {
      this.inventoryPercent = Number(response.data) * 100;
      loading.close();
    }, 200);
  }

  /**
   * Метод определения типа баджа.
   */
  private getType(): string {
    if (this.inventoryPercent === null) return "danger";
    else if (this.inventoryPercent < 60) return "danger";
    else if (this.inventoryPercent < 90) return "warning";
    else return "success";
  }
}
</script>
